/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").  
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at sunpinyin/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at sunpinyin/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#ifndef SUNPY_IMI_DATA_H
#define SUNPY_IMI_DATA_H

#include "portability.h"

#include <stdarg.h>

#include "slm.h"
#include "pytrie.h"

void print_wide(const TWCHAR* wstr);

/**
 * Data of the IM implementation shared by all Desktop/Session(IC)
 */
class CIMIData{
public:
    CIMIData()
        : m_pPinyinTrie(NULL), m_pLM(NULL) { }

    ~CIMIData()
        { clear(); }

    CThreadSlm*
    getSlm()
        { return m_pLM; }

    CPinyinTrie*
    getPinyinTrie()
        { return m_pPinyinTrie; }

    bool
    loadResource(const char* lm_file_path, const char* pytrie_file_path);

    void
    clear();

public:
    CPinyinTrie     *m_pPinyinTrie;
    CThreadSlm      *m_pLM;
};

#endif
