/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").  
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at sunpinyin/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at sunpinyin/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#ifndef _IMI_OPTIONS_H
#define _IMI_OPTIONS_H

#include "portability.h"

class CIMIOptions {
public:
    virtual ~CIMIOptions();

    virtual CIMIOptions* clone() const = 0;

    virtual bool operator==(const CIMIOptions* p2) const = 0;

    virtual bool copy(const CIMIOptions* p2) = 0;
};

class CSunpinyinOptions :  public CIMIOptions {

public:
    virtual ~CSunpinyinOptions();

    virtual CIMIOptions* clone() const;

    virtual bool operator==(const CIMIOptions* p2) const;

    virtual bool copy(const CIMIOptions* p2);

public:
    int         m_ViewType;
    int         m_GBK;
    int         m_MinusAsPageUp;
    int         m_CommaAsPageUp;
    int         m_BracketAsPageUp;

    int         m_MemoryPower;
    int         m_ContextRanking;
    int         m_LayoutVeritcal;
    int         m_Fuzzy;
    int         m_Fuzzy_zh;
    int         m_Fuzzy_ch;
    int         m_Fuzzy_sh;
    int         m_Fuzzy_ln;
    int         m_Fuzzy_fh;
    int         m_Fuzzy_ang;
    int         m_Fuzzy_eng;
    int         m_Fuzzy_ing;

public:
    CSunpinyinOptions();

    bool        isPageUpKey(unsigned keycode, unsigned keychar, unsigned mask);
    bool        isPageDnKey(unsigned keycode, unsigned keychar, unsigned mask);
};

#endif
