/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").  
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at sunpinyin/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at sunpinyin/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#ifndef SUNPINYIN_IMI_WINHANDLER_H
#define SUNPINYIN_IMI_WINHANDLER_H

#include "portability.h"

#include "imi_uiobjects.h"
#include "imi_options.h"

#include <iconv.h>

class CIMIView;

/*@}*/

class CIMIWinHandler
{
public:
    enum {
        STATUS_ID_CN,
        STATUS_ID_FULLPUNC,
        STATUS_ID_FULLSIMBOL
    };

public:
    CIMIWinHandler() : m_pPrefLink(NULL)/*, mp_mainwin(NULL), mp_view(NULL)*/ { }

    /*@{*/
    virtual ~CIMIWinHandler();

    /** commit a string, normally the converted result */
    virtual void commit(const TWCHAR* wstr);

    /** when a key is not processed */
    virtual void throwBackKey(unsigned keycode, unsigned keyvalue, unsigned modifier);

    /** Update window's preedit area. */
    virtual void updatePreedit(const IPreeditString* ppd);

    /** Update window's candidates area. */
    virtual void updateCandidates(const ICandidateList* pcl);

    /** Update status area. */
    virtual void updateStatus(int key, int value);

    virtual void setOptions(CIMIOptions* pp);
    /*@}*/

protected:
    //CIMIView       *mp_view;
    CIMIOptions*    m_pPrefLink;
};

#endif
