/*
 * Copyright (c) 2007 Kov Chai <tchaikov@gmail.com>
 */

#ifndef IMI_SCIMWIN_H
#define IMI_SCIMWIN_H

#include "sunpinyin_lookup_table.h"
#include "imi_winHandler.h"

class SunPyInstance;

class CScimWinHandler : public CIMIWinHandler
{
public:
    CScimWinHandler(SunPyInstance* ime, SunLookupTable* lookup_table);

    /* inherited methods implementation */
    /*@{*/
    virtual ~CScimWinHandler();

    /** commit a string, normally the converted result */
    virtual void commit(const TWCHAR* wstr);
    
    /** when a key is not processed */
    virtual void throwBackKey(unsigned keycode, unsigned keyvalue, unsigned modifier);

    /** Update window's preedit area using a GTK widget. */
    virtual void updatePreedit(const IPreeditString* ppd);

    /** Update window's candidates area using a GTK widget. */
    virtual void updateCandidates(const ICandidateList* pcl);

    /** Update status of current session using a GTK buttons. */
    virtual void  updateStatus(int key, int value);

    virtual void setOptions(CIMIOptions* pp);
    /*@}*/

private:
    /** load the images representing CN/EN, FULL/HALF PUNC|Simbol Simbol STATE*/
    void load_images();

private:
    char m_buf[512];
    SunPyInstance      *m_ime;
    SunLookupTable     *m_lookup_table;
};

#endif//IMI_SCIMWIN_H
