/*
 * Copyright (c) 2007 Kov Chai <tchaikov@gmail.com>
 */

#ifndef SUNPINYIN_LOOKUP_TABLE_H
#define SUNPINYIN_LOOKUP_TABLE_H

#define Uses_SCIM_LOOKUP_TABLE
#include <scim.h>

using namespace scim;

class ICandidateList;

class SunLookupTable : public LookupTable
{
    class SunLookupTableImpl;
    SunLookupTableImpl* m_impl;

    SunLookupTable (const SunLookupTable &);
    const SunLookupTable & operator= (const SunLookupTable &);

    uint32 m_total;
    
public:
    SunLookupTable(int page_size = 10);
    ~SunLookupTable();
    virtual WideString get_candidate (int index) const;
    virtual AttributeList get_attributes (int index) const;
    virtual uint32 number_of_candidates () const;
    virtual void clear();

public:
    /**
     * @brief Update all candidates in current page
     * called by winHandler::updateCandidates()
     */
    void update(const ICandidateList& cl);

private:
    /**
     * translate the index in the list to the index in current page
     */
    int translate_index(int index) const;
    int append_candidate(const ICandidateList& cl, int i, int begin);
};

#endif//SUNPINYIN_LOOKUP_TABLE_H
